
@ECHO OFF
REM W. Dwyne 2023 
REM A bit of setup:
REM			Code Page to UTF8 CHCP 65001
chcp 65001
REM			Console window size mode con: cols=120 lines=35 Note: requires "Run as Administrator"
mode con: cols=120 lines=100
REM			Define a Back Space which is useful for formatting output.
SET backspace= 
color 70
REM top left = 218 top right = 191 vertical line = 179 bottom left = 192 bottom right = 217
ECHO:		┌────────────────────────────────────────────────────────────────────────┐
ECHO:		│                         System File Scan                               │
ECHO:		└────────────────────────────────────────────────────────────────────────┘
ECHO:
ECHO:		%time% %date% - {%~f0 %* %~t0}
REM			Check for admin permissions
   
NET SESSION >NUL 2>&1
    IF %ERRORLEVEL% == 0 (
        GOTO PERM-OK )
		
ECHO:		
ECHO:
ECHO:      	This batch file requires Administrator Privileges
ECHO: 
ECHO:		You need to:
ECHO:		A -
ECHO:		Right click on the batch(.bat) then click on "Run as administrator"
ECHO:			or
ECHO:		B -
ECHO:		Right click on the batch file then click on "Show more options" then click on "Create shortcut"
ECHO:		Next
ECHO:		Right click your shortcut then click on "properties" then click on "advanced"
ECHO:		  then click on "Run as administrator" then "OK" then "OK"
ECHO:		You can move the shortcut to the Desktop/rename/change icon etc, it will 
ECHO:		  run this procedure with administrator rights.
ECHO:		
GOTO END



:PERM-OK
ECHO:
ECHO:      	System Scan.bat is running as Admin
ECHO:
ECHO:	Batch Procedure to run system tools:
ECHO: 
ECHO:		First - SFC  (System File Checker)
ECHO:		Then, if errors - DISM (Deployment Image Servicing and Management)
ECHO:		OR
ECHO:		Run SFC or DISM individually.
ECHO:
SET /P ACTION=%backspace%	Ok to continue ? (Y/[N]) or (S)fc or (D)ism ? 
IF /I "%ACTION%"=="Y" GOTO SFC
IF /I "%ACTION%"=="S" GOTO SFC
IF /I "%ACTION%"=="D" GOTO DISM
ECHO:
ECHO:	Exiting at your request. %ACTION%
GOTO END

:SFC
ECHO:
ECHO:	Starting SFC
sfc /scannow
if %ERRORLEVEL% NEQ 0 if %ACTION% == "Y" GOTO DISM
if %ERRORLEVEL% NEQ 0 GOTO ERR
ECHO:
ECHO:	SFC completed with status Success (Error = %ERRORLEVEL%)
GOTO END

:DISM
if %ACTION% == "Y" ECHO:	SFC errors (Error = %ERRORLEVEL%) - Starting DISM
ECHO:	
DISM.exe /Online /Cleanup-image /Restorehealth
if %ERRORLEVEL% NEQ 0 GOTO ERR
ECHO:	DISM completed with status Success (Error = %ERRORLEVEL%)
GOTO END

:ERR
ECHO:	Errors encountered please check! (Error = %ERRORLEVEL%)

:END
ECHO:
ECHO: 	Press any key to exit.
PAUSE >nul